package com.muyu.system.context;

import com.muyu.system.domain.LoginUserInfo;

/**
 * @Description: 系统用户上下文
 * @author: MuYu
 * @date: 2024/9/10-下午5:52
 */
public class SystemUserContext {

    /**
     * 系统用户线程变量
     */
    private static final ThreadLocal<LoginUserInfo> basicContextLocal = new ThreadLocal<>();


    public static LoginUserInfo get() {
        return basicContextLocal.get();
    }

    public static void set(LoginUserInfo value) {
        basicContextLocal.set(value);
    }

    public static void remove() {
        basicContextLocal.remove();
    }
}
