package com.muyu;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.transaction.annotation.EnableTransactionManagement;

/**
 * @author DongZeLiang
 * @version 1.0
 * @description 车辆模拟启动类
 * @date 2023/11/9
 */
@SpringBootApplication(exclude = {DataSourceAutoConfiguration.class})
@MapperScan(value = "com.muyu.**.mapper")
@EnableTransactionManagement
public class VehicleSimulationApplication {

    public static void main(String[] args) {
        SpringApplication.run(VehicleSimulationApplication.class, args);
    }
}
