package com.muyu.vehicle.api;

import com.dtflys.forest.annotation.JSONBody;
import com.dtflys.forest.annotation.Post;
import com.muyu.vehicle.api.req.VehicleConnectionReq;
import com.muyu.web.common.Result;
import com.muyu.web.domain.model.MqttServerModel;

/**
 * @author DongZl
 * @description: 客户端的管理
 * @Date 2023-11-28 上午 10:20
 */
public interface ClientAdmin {

    /**
     * 获取车辆负载地址
     * @param vehicleConnectionReq 请求信息
     * @return 响应结果
     */
    @Post(
            url = "{vehicleLoadUrl}"/*,
            headers = {
                    "X-co-il: DH5I9OIG+N=="
            }*/
    )
    public Result<MqttServerModel> getVehicleLoadAddr ( @JSONBody VehicleConnectionReq vehicleConnectionReq);
}
